#ifndef __DataFile_h
#define __DataFile_h

#include <stdio.h>
#include <math.h>
#include <string.h>

#include "Global.h"
#include "WebNode.h"
#include "wv.h"

class DataFile {
  class OutFile *vrmlfile;

public:
  char name[256];
  ELEV **data;
  COOR dimx, dimy;

  DataFile(char *fname);
  ~DataFile();

  virtual void Read() {};

  void AllocMem();
  void FreeMem();

  virtual ELEV & operator()(int i, int j)
  { 
    return data[i][j];
  }
};

class PGMFile : public DataFile {
public:

  PGMFile(char *fname) : DataFile(fname) {};
  virtual void Read();
};

class TableFile : public DataFile {
public:

  TableFile(char *fname) : DataFile(fname) {};
  virtual void Read();
};

class URLFile : public DataFile 
{
public:
  
  URLFile(char *url) : DataFile(url) {} ;
  virtual void Read();
};

class URLCompressedDEM : public DataFile 
{
public:
  URLCompressedDEM(char *url) : DataFile(url) {} ;
  virtual void Read();
};


#endif
